## wcc 0.0.2+dfsg

=== Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

CFLAGS := -W -Wall -Wno-discarded-qualifiers -Wno-int-conversion -Wno-unused-parameter -Wno-unused-function -Wno-unused-result -fpie -pie -fPIC -g3 -ggdb -I../../include  -I./include/sflib/ -I./include -I../../include/  -Wno-incompatible-pointer-types  -fstack-protector-all -Wl,-z,relro,-z,now -DPACKAGE -DPACKAGE_VERSION -masm=intel -rdynamic -D_fORTIFY_SOURCE=2 -O2

all:
	mkdir -p bin
	cd src && make CFLAGS=" $(CFLAGS)"

documentation:
	cd src && doxygen ./tex/project.cfg
	cd doc/latex && make && cp refman.pdf ../WCC_internal_documentation.pdf
clean:
	cd src && make clean
	rm -f ./bin/*

clean-documentation:
#	rm -rf ./doc/html
	rm -rf ./doc/latex

install:
	cd src && make install

uninstall:
	cd src && make uninstall

=== src/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

all::
	cd wcc && make CFLAGS=" $(CFLAGS)"
	cd wld && make CFLAGS=" $(CFLAGS)"
	cd wsh && make CFLAGS=" $(CFLAGS)"
	cd tools && make CFLAGS=" $(CFLAGS)"
clean:
	cd wcc && make clean
	cd wld && make clean
	cd wsh && make clean
	cd tools && make clean

install:
	cd wcc && make install
	cd wld && make install
	cd wsh && make install
	cd tools && make install

uninstall:
	cd wcc && make uninstall
	cd wld && make uninstall
	cd wsh && make uninstall
	cd tools && make uninstall

=== src/tools/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

all::
	cp wldd ../../bin/
	cp wcch ../../bin/
test:

clean:
	rm ../../bin/wldd -f
	rm ../../bin/wcch -f

install:
	cp wldd $(DESTDIR)/usr/bin/wldd
	cp wcch $(DESTDIR)/usr/bin/wcch

uninstall:
	rm $(DESTDIR)/usr/bin/wldd -f
	rm $(DESTDIR)/usr/bin/wcch -f

=== src/wcc/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

# Note:
# You will need to provide your own 32b static library for libbfd if you 
# want to cross compile to 32b intel from amd64. Simply installing
# the 32b library on top of a 64b system breaks ubuntu.
#
# Note that the 64bits version of wcc generates 64b ELF files,
# while the 32bits version generates 32b ELF files.
# So there is a point in having both. Cross compiling to
# other architectures (eg ARM) seems pointless : the 32b intel
# version can process 32b ARM, and the 64b version process AARCH64.
#
# Compiling natively on ARM or other architectures should work provided
# capstone and libbfd are installed on the system.
#

WCC :=  ./wcc
FILE := file

all::
	$(CC) $(CFLAGS) wcc.c -o wcc -lbfd -lelf -lcapstone
#	$(CC) $(CFLAGS) -m32 -Wl,-rpath /home/jonathan/solution-exp/unlinking/awareness/self/wcc/src/wcc/lib32/  wcc.c -o wcc32 -lelf ./lib32/libbfd-2.24-system.so ./lib32/libcapstone.so.3

	cp wcc ../../bin/
#	cp wcc32 ../../bin/

test::
	$(WCC) /bin/ls -o ./ls.o -c
	$(CC) ./ls.o -o ./ls.so -shared -g3 -ggdb -O0
	$(FILE) ls.so
clean:
	rm -f wcc a.out wcc.o core wcc32 ls.o ls.so

install:
	cp wcc $(DESTDIR)/usr/bin/wcc
#	cp wcc32 $(DESTDIR)/usr/bin/wcc32

uninstall:
	rm $(DESTDIR)/usr/bin/wcc -f
#	rm $(DESTDIR)/usr/bin/wcc32 -f

=== src/wld/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

# Note:
# You will need to provide your own 32b static library for libbfd if you 
# want to cross compile to 32b intel from amd64. Simply installing
# the 32b library on top of a 64b system using apt-get breaks ubuntu.
#
# Note that the 64b version and 32b versions alike can process
# any ELF (from any architecture/OS/endianess).
#

all::
	$(CC) $(CFLAGS) wld.c -o wld -lbfd
#	$(CC) $(CFLAGS) wld.c -o wld32 -m32 ../lib32/usr/lib/libbfd.a

	cp wld ../../bin/
#	cp wld32 ../../bin/
test:

clean:
	rm -f wld wld32 a.out

install:
	cp wld $(DESTDIR)/usr/bin/wld
#	cp wld32 $(DESTDIR)/usr/bin/wld32

uninstall:
	rm $(DESTDIR)/usr/bin/wld -f
#	rm $(DESTDIR)/usr/bin/wld32 -f

=== src/wsh/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

OBJLIB := ./lua/src/liblua.a ./openlibm/libopenlibm.a

#CFLAGS := -rdynamic -W -Wall -Wextra -O0 -mpreferred-stack-boundary=12 -mstackrealign -ggdb -g3 -Wno-unused-but-set-variable -Wno-unused-parameter -I./include -rdynamic -I../../include/ -I./luajit-2.0/src/ -Wl,-E -Wl,-z,now
#OBJLIB := ./luajit-2.0/src/libluajit.a ./openlibm/libopenlibm.a 

all::
	cd openlibm && make CFLAGS="-fpie -fPIC"
	cd lua && make linux CFLAGS="-fpie -fPIC"
	$(CC) $(CFLAGS) wsh.c -o wsh.o -c -fpie -fPIC -ldl -lreadline
	$(CC) $(CFLAGS) wshmain.c -o wshmain.o -c -fpie -fPIC -ldl -lreadline
	$(CC) $(CFLAGS) helper.c -o helper.o -c -fpie -fPIC
	$(CC) $(CFLAGS) linenoise/linenoise.c -o linenoise.o -c -fpie -fPIC
	$(CC) $(CFLAGS) wsh.o helper.o linenoise.o -shared -fPIC -o libwitch.so
	ar cr libwitch.a wsh.o helper.o linenoise.o
	$(CC) $(CFLAGS) wsh.o helper.o linenoise.o wshmain.o -o wsh -Wl,-T -Wl,script.lds -liberty $(OBJLIB) -ldl

	cp wsh ../../bin/

test:
	cd tests && make

clean::
	rm wsh helper.o wsh.o wshmain.o libwitch.so libwitch.a linenoise.o learnwitch.log -f
	cd openlibm && make clean
	cd lua && make clean
	cd tests && make clean

deepclean:
	cd openlibm && make clean
	cd lua && make clean
	make clean

install::
	mkdir -p $(DESTDIR)/usr/share/wcc/
	cp -r ./scripts $(DESTDIR)/usr/share/wcc/
	cp wsh $(DESTDIR)/usr/bin/wsh

uninstall::
	rm -rf $(DESTDIR)/usr/share/wcc/
	rm -f $(DESTDIR)/usr/bin/wsh

binfmt:
	sudo update-binfmts --install wsh /usr/bin/wsh --extension wsh

=== src/wsh/linenoise/Makefile ===
linenoise_example: linenoise.h linenoise.c

linenoise_example: linenoise.c example.c
	$(CC) -Wall -W -Os -g -o linenoise_example linenoise.c example.c

clean:
	rm -f linenoise_example

=== src/wsh/tests/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

all::
	cd apache2 && make
	cd  sshd && make
	cd  sshd2 && make

clean:
	cd apache2 && make clean
	cd  sshd && make clean
	cd  sshd2 && make clean

=== doc/presentations/demos_defcon24_2016/apache/Makefile ===
CC	:=	gcc
CFLAGS	:=	-W -Wall
LDFLAGS	:=	/usr/sbin/apache2

all::
	$(CC) $(CFLAGS) ap2version.c -o ap2version $(LDFLAGS)

=== doc/presentations/demos_defcon24_2016/proftpd/Makefile ===
CC	:=	gcc
CFLAGS	:=	-W -Wall
LDFLAGS	:=	-ldl -T script.lds

all::
	cp /usr/sbin/proftpd /tmp
	wld -libify /tmp/proftpd
	mv /tmp/proftpd /tmp/proftpd.so
	$(CC) $(CFLAGS) demo0.c -o demo0 $(LDFLAGS)
	$(CC) $(CFLAGS) demo1.c -o demo1 $(LDFLAGS)
	$(CC) $(CFLAGS) demo2.c -o demo2 $(LDFLAGS)
	$(CC) $(CFLAGS) demo3.c -o demo3 $(LDFLAGS)

clean::
	rm demo0 demo1 demo2 demo3

=== src/wsh/openlibm/test/Makefile ===
OPENLIBM_HOME=$(abspath ..)
include ../Make.inc

# Set rpath of tests to builddir for loading shared library
OPENLIBM_LIB = -L.. -lopenlibm
ifeq ($(OS),Linux)
OPENLIBM_LIB += -Wl,-rpath=$(OPENLIBM_HOME)
endif

all: test-double test-float # test-double-system test-float-system

bench: bench-syslibm bench-openlibm

test-double: test-double.c libm-test.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add_TARGET_$(ARCH)) $(LDFLAGS) $@.c -D__BSD_VISIBLE -I ../include -I../src $(OPENLIBM_LIB) -o $@

test-float: test-float.c libm-test.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add_TARGET_$(ARCH)) $(LDFLAGS) $@.c -D__BSD_VISIBLE -I ../include -I../src $(OPENLIBM_LIB) -o $@

test-double-system: test-double.c libm-test.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add_TARGET_$(ARCH)) $(LDFLAGS) $< -DSYS_MATH_H -lm -o $@

test-float-system: test-float.c libm-test.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add_TARGET_$(ARCH)) $(LDFLAGS) $< -DSYS_MATH_H -lm -o $@

bench-openlibm: libm-bench.cpp
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add_TARGET_$(ARCH)) $(LDFLAGS) $< $(OPENLIBM_LIB) -o $@

bench-syslibm: libm-bench.cpp
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add_TARGET_$(ARCH)) $(LDFLAGS) $< -lm -o $@

clean:
	rm -fr test-double test-float test-double-system test-float-system bench-openlibm bench-syslibm *.dSYM

=== src/wsh/tests/apache2/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

CC := gcc 
CFLAGS := -W -Wall -Wextra
LDFLAGS := /usr/sbin/apache2

all::
	$(CC) $(CFLAGS) $(LDFLAGS) ap2v.c -o ap2v

clean:
	rm ap2v -f

## wcc 0.0.2%2Bdfsg

=== debian/control ===
Source: wcc
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Philippe Thierry <philou@debian.org>
Build-Depends:
 debhelper (>= 12),
 binutils-dev,
 libcapstone-dev,
 libelf-dev,
 libreadline-dev,
 libgsl-dev,
 clang,
 libiberty-dev,
 libzstd-dev,
 liblua5.3-dev,
 pkg-config
Built-Using:
 binutils-dev
Standards-Version: 4.5.0
Homepage: https://github.com/endrazine/wcc
Vcs-Git: https://salsa.debian.org/pkg-security-team/wcc.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/wcc

Package: wcc
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: lua
Description: Collection of tools to manipulate binaries and shared objects
 This tool permits one to manipulate binaries and shared liraries to reuse
 their API into an external usage, as a relocatable object that
 can be linked to a new project, or through an interpreter (wsh)
 to execute internal API directly.

## wcc 0.0.2+dfsg

=== debian/changelog ===
wcc (0.0.2+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Update team maintainer address to Debian Security Tools
    <team+pkg-security@tracker.debian.org>
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org
  * Fix broken dependency on mktemp in DEP-8 test.
    Thanks to Matthias Klose for the patch. (Closes: #890043)
  * Update Standards-Version to 4.1.3 (no change required)
  * Add lua to Suggests to appease lintian for /usr/share/wcc/scripts/print_G

 -- Raphaël Hertzog <hertzog@debian.org>  Sat, 10 Mar 2018 00:46:15 +0100

wcc (0.0.2+dfsg-2) unstable; urgency=medium

  * Various update (Closes: #873783): see belowing comments:
  * using packaged openlibm instead of embedded one.
    embedded openlibm was not able to be built on various arches
  * reducing target to amd64.
    the ldscript used to map relocated section in wsh has only been made for
    this target, making impossible to build wsh for other target than amd64
    without building specific ldscripts for each of them
  * add support to Debian/kfreebsd and Debian/Hurd.
    by embedding the elf-em macros list only when needed
  * This update also correct the binutils dependency (Closes: 873821).
    The error comes from an autogenerated dependency version build
    to binutils
    the udate as the same effect as a binNMU request, the package being
    rebuilt
  * Update std-version to 4.1.0

 -- Philippe Thierry <phil@reseau-libre.net>  Thu, 31 Aug 2017 22:31:12 +0200

wcc (0.0.2+dfsg-1) unstable; urgency=low

  [ Philippe Thierry ]
  * Initial release (Closes: #861390).
  * Updated various spelling error.
  * Updated man pages.
  * Add upstream changelog generation from git commit msg.
  * Updated upstream README to clean installation specific content.

  [ Raphaël Hertzog ]
  * Fix the permissions of the various script files.

 -- Philippe Thierry <phil@reseau-libre.net>  Tue, 23 May 2017 10:32:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: wcc
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
-Uploaders: Philippe Thierry <philou@debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Uploaders: Philippe Thierry <phil@reseau-libre.net>
 Build-Depends:
- debhelper (>= 12),
+ debhelper (>= 10),
  binutils-dev,
  libcapstone-dev,
  libelf-dev,
@@ -13,12 +12,10 @@
  libgsl-dev,
  clang,
  libiberty-dev,
- libzstd-dev,
  liblua5.3-dev,
+ libopenlibm-dev,
  pkg-config
-Built-Using:
- binutils-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.1.3
 Homepage: https://github.com/endrazine/wcc
 Vcs-Git: https://salsa.debian.org/pkg-security-team/wcc.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/wcc

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_install:
	@echo using dh_install manually	

override_dh_fixperms:
	chmod 644 debian/wcc/usr/share/wcc/scripts/debug
	dh_fixperms

%:
	dh $@ 

# get back current tag release notes from GitHub
mkrelease:
	quilt push changelog.patch
	debian/lib/gen_changelog.sh
	quilt refresh
	quilt pop -a
	@echo
	@echo This target is made to fail intentionally, to make sure
	@echo that it is NEVER run during the automated build. Please
	@echo ignore the following error, the changelog file has been
	@echo generated SUCCESSFULLY.
	@echo
	exit 1

=== debian/tests/control ===
Tests: wsh-libs.wsh
Restrictions: allow-stderr
Depends: @, openssh-client

Test-command: ./debian/tests/wsh-ssl.wsh /usr/bin/ssh
Restrictions: allow-stderr
Depends: @, openssh-client

Tests: wldd.sh
Depends: @, openssh-server

Tests: wcc.sh

## wcc 0.0.7%2Bdfsg

=== src/wsh/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # This file is part of the Witchcraft Compiler Collection
-# Copyright 2016 Jonathan Brossard
+# Copyright 2016-2024 Jonathan Brossard
 #
 # Homepage: https://github.com/endrazine/wcc/
 #

=== src/wsh/openlibm/Makefile ===
OPENLIBM_HOME=$(abspath .)
include ./Make.inc

SUBDIRS = src $(ARCH) bsdsrc
ifneq ($(ARCH), arm)
ifneq ($(ARCH), powerpc)
SUBDIRS += ld80
endif
endif

define INC_template
TEST=test
override CUR_SRCS = $(1)_SRCS
include $(1)/Make.files
SRCS += $$(addprefix $(1)/,$$($(1)_SRCS))
endef

DIR=test

$(foreach dir,$(SUBDIRS),$(eval $(call INC_template,$(dir))))

DUPLICATE_NAMES = $(filter $(patsubst %.S,%,$($(ARCH)_SRCS)),$(patsubst %.c,%,$(src_SRCS)))
DUPLICATE_SRCS = $(addsuffix .c,$(DUPLICATE_NAMES))

OBJS =  $(patsubst %.f,%.f.o,\
	$(patsubst %.S,%.S.o,\
	$(patsubst %.c,%.c.o,$(filter-out $(addprefix src/,$(DUPLICATE_SRCS)),$(SRCS)))))

# If we're on windows, don't do versioned shared libraries.  If we're on OSX,
# put the version number before the .dylib.  Otherwise, put it after.
ifeq ($(OS), WINNT)
OLM_MAJOR_MINOR_SHLIB_EXT := $(SHLIB_EXT)
else
ifeq ($(OS), Darwin)
OLM_MAJOR_MINOR_SHLIB_EXT := $(SOMAJOR).$(SOMINOR).$(SHLIB_EXT)
OLM_MAJOR_SHLIB_EXT := $(SOMAJOR).$(SHLIB_EXT)
else
OLM_MAJOR_MINOR_SHLIB_EXT := $(SHLIB_EXT).$(SOMAJOR).$(SOMINOR)
OLM_MAJOR_SHLIB_EXT := $(SHLIB_EXT).$(SOMAJOR)
endif
endif

.PHONY: all check test clean distclean \
	install install-static install-shared install-pkgconfig install-headers

all: libopenlibm.a libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)

check test: test/test-double test/test-float
	test/test-double
	test/test-float

libopenlibm.a: $(OBJS)
	$(AR) -rcs libopenlibm.a $(OBJS)

libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT): $(OBJS)
	$(CC) -shared $(OBJS) $(LDFLAGS) $(LDFLAGS_add) -Wl,$(SONAME_FLAG),libopenlibm.$(OLM_MAJOR_SHLIB_EXT) -o $@
ifneq ($(OS),WINNT)
	ln -sf $@ libopenlibm.$(OLM_MAJOR_SHLIB_EXT)
	ln -sf $@ libopenlibm.$(SHLIB_EXT)
endif

test/test-double: libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
	$(MAKE) -C test test-double

test/test-float: libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
	$(MAKE) -C test test-float

clean:
	rm -f amd64/*.o arm/*.o bsdsrc/*.o i387/*.o ld128/*.o ld80/*.o src/*.o
	rm -f libopenlibm.a libopenlibm.*$(SHLIB_EXT)*
	$(MAKE) -C test clean

openlibm.pc: openlibm.pc.in Make.inc Makefile
	echo "prefix=${prefix}" > openlibm.pc
	echo "version=${VERSION}" >> openlibm.pc
	cat openlibm.pc.in >> openlibm.pc

install-static: libopenlibm.a
	mkdir -p $(DESTDIR)$(libdir)
	cp -f -a libopenlibm.a $(DESTDIR)$(libdir)/

install-shared: libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
	mkdir -p $(DESTDIR)$(shlibdir)
	cp -f -a libopenlibm.*$(SHLIB_EXT)* $(DESTDIR)$(shlibdir)/

install-pkgconfig: openlibm.pc
	mkdir -p $(DESTDIR)$(pkgconfigdir)
	cp -f -a openlibm.pc $(DESTDIR)$(pkgconfigdir)/

install-headers:
	mkdir -p $(DESTDIR)$(includedir)/openlibm
	cp -f -a include/*.h $(DESTDIR)$(includedir)/openlibm
	cp -f -a src/*.h $(DESTDIR)$(includedir)/openlibm

install: install-static install-shared install-pkgconfig install-headers

=== src/wsh/tests/sshd2/Makefile ===
#
# This file is part of the Witchcraft Compiler Collection
# Copyright 2016-2022 Jonathan Brossard
#
# Homepage: https://github.com/endrazine/wcc/
#
# This file is licensed under MIT License.
#

CC := gcc 
CFLAGS := -W -Wall -Wextra -Wl,-e__main
LDFLAGS := /usr/sbin/sshd

all::
	$(CC) $(CFLAGS) $(LDFLAGS) sshd2.c -o sshd2

clean:
	rm -rf sshd2

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_install:
	@echo using dh_install manually	

override_dh_fixperms:
	chmod 644 debian/wcc/usr/share/wcc/scripts/debug
	dh_fixperms

override_dh_gencontrol:
	dh_gencontrol -- -Vwcc:Built-Using="$(shell dpkg-query --show -f '$${source:Package} (=$${source:Version}),' binutils-dev)"

%:
	dh $@
